<html>
<head>
<title>OGRE: OgreStringInterface.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreStringInterface.h</h1><a href="OgreStringInterface_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __StringInterface_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __StringInterface_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00041"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a">00041</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a7b72a218a6d93dfbcb77e208eaa3feeb">00043</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a7b72a218a6d93dfbcb77e208eaa3feeb">PT_BOOL</a>,
<a name="l00044"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a6346202346c62e0d276c03eb2f258b16">00044</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a6346202346c62e0d276c03eb2f258b16">PT_REAL</a>,
<a name="l00045"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a6a6d06f6d2147d82b892bee309ff466f">00045</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a6a6d06f6d2147d82b892bee309ff466f">PT_INT</a>,
<a name="l00046"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a960735d7150a41f8c25be3e5d459e5ef">00046</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a960735d7150a41f8c25be3e5d459e5ef">PT_UNSIGNED_INT</a>,
<a name="l00047"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ac1ae17fd22246104d7a7794fcf89e1e1">00047</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ac1ae17fd22246104d7a7794fcf89e1e1">PT_SHORT</a>,
<a name="l00048"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924aca32cf2526bd9f0ec645331b9a1093c1">00048</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924aca32cf2526bd9f0ec645331b9a1093c1">PT_UNSIGNED_SHORT</a>,
<a name="l00049"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a663563417c2b019e268ba62dc4b1c587">00049</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a663563417c2b019e268ba62dc4b1c587">PT_LONG</a>,
<a name="l00050"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a08dbf5d4856777b3dd0dfd7f6d82cd46">00050</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a08dbf5d4856777b3dd0dfd7f6d82cd46">PT_UNSIGNED_LONG</a>,
<a name="l00051"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a631b8a9e92ad1186744a5fa9521b08dc">00051</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a631b8a9e92ad1186744a5fa9521b08dc">PT_STRING</a>,
<a name="l00052"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ad1f53213a85c2b5518e8b974cbbbea76">00052</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ad1f53213a85c2b5518e8b974cbbbea76">PT_VECTOR3</a>,
<a name="l00053"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ada60f8ff24cfcc03772b69968f3aa30f">00053</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924ada60f8ff24cfcc03772b69968f3aa30f">PT_MATRIX3</a>,
<a name="l00054"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a9cde1dc36b3e39a8a4e7a2b9bba6d78d">00054</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a9cde1dc36b3e39a8a4e7a2b9bba6d78d">PT_MATRIX4</a>,
<a name="l00055"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a2971f5bea77e8de65d015df46f67733c">00055</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a2971f5bea77e8de65d015df46f67733c">PT_QUATERNION</a>,
<a name="l00056"></a><a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a70b475c72e98912203dc005ef4fd9ffb">00056</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a70b475c72e98912203dc005ef4fd9ffb">PT_COLOURVALUE</a>
<a name="l00057"></a>00057     };
<a name="l00058"></a>00058 
<a name="l00060"></a><a class="code" href="classOgre_1_1ParameterDef.html">00060</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection...">ParameterDef</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classOgre_1_1ParameterDef.html#b22036d8dcec3fe262e88316e55d9a13">00063</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name;
<a name="l00064"></a><a class="code" href="classOgre_1_1ParameterDef.html#e96c017b7f2f644978e2bfd9769b55c2">00064</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> description;
<a name="l00065"></a><a class="code" href="classOgre_1_1ParameterDef.html#5f5634c1ecf86d49da2cccdd97641c6a">00065</a>         <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a> paramType;
<a name="l00066"></a><a class="code" href="classOgre_1_1ParameterDef.html#0070696ef2e47e06585ca37ad1223836">00066</a>         <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection...">ParameterDef</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newDescription, <a class="code" href="namespaceOgre.html#4b8cfe4e77d7d21264a6497c06ed924a" title="List of parameter types available.">ParameterType</a> newType)
<a name="l00067"></a>00067             : name(newName), description(newDescription), paramType(newType) {}
<a name="l00068"></a>00068     };
<a name="l00069"></a><a class="code" href="namespaceOgre.html#1838c2b0619ade1f5e29767062212872">00069</a>     <span class="keyword">typedef</span> std::vector&lt;ParameterDef&gt; <a class="code" href="namespaceOgre.html#1838c2b0619ade1f5e29767062212872">ParameterList</a>;
<a name="l00070"></a>00070 
<a name="l00072"></a><a class="code" href="classOgre_1_1ParamCommand.html">00072</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span> = 0;
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val) = 0;
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classOgre_1_1ParamCommand.html#44288c733303c12a4cb30f483ee006ee">00078</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>() { }
<a name="l00079"></a>00079     };
<a name="l00080"></a><a class="code" href="namespaceOgre.html#b86c7cbfc251d38852599a5be6a6763a">00080</a>     <span class="keyword">typedef</span> std::map&lt;String, ParamCommand* &gt; <a class="code" href="namespaceOgre.html#b86c7cbfc251d38852599a5be6a6763a">ParamCommandMap</a>;
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1ParamDictionary.html">00083</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>
<a name="l00084"></a>00084     {
<a name="l00085"></a><a class="code" href="classOgre_1_1ParamDictionary.html#f1037345f6c7a90f967a44cb1eb6dadc">00085</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a>;
<a name="l00086"></a>00086     <span class="keyword">protected</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1ParamDictionary.html#37e4ea1d0c014e743b815b6a829f5a75">00088</a>         <a class="code" href="namespaceOgre.html#1838c2b0619ade1f5e29767062212872">ParameterList</a> mParamDefs;
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1ParamDictionary.html#374491774db59af87966f14795737996">00091</a>         <a class="code" href="namespaceOgre.html#b86c7cbfc251d38852599a5be6a6763a">ParamCommandMap</a> mParamCommands;
<a name="l00092"></a>00092 
<a name="l00094"></a><a class="code" href="classOgre_1_1ParamDictionary.html#6b324fb02bdd70f7fdd6566fb634e1dc">00094</a>         <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* getParamCommand(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096             ParamCommandMap::iterator i = mParamCommands.find(name);
<a name="l00097"></a>00097             <span class="keywordflow">if</span> (i != mParamCommands.end())
<a name="l00098"></a>00098             {
<a name="l00099"></a>00099                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00100"></a>00100             }
<a name="l00101"></a>00101             <span class="keywordflow">else</span>
<a name="l00102"></a>00102             {
<a name="l00103"></a>00103                 <span class="keywordflow">return</span> 0;
<a name="l00104"></a>00104             }
<a name="l00105"></a>00105         }
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classOgre_1_1ParamDictionary.html#10d47cfb52e9a32917e5a0965a7b7bb8">00107</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* getParamCommand(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword">        </span>{
<a name="l00109"></a>00109             ParamCommandMap::const_iterator i = mParamCommands.find(name);
<a name="l00110"></a>00110             <span class="keywordflow">if</span> (i != mParamCommands.end())
<a name="l00111"></a>00111             {
<a name="l00112"></a>00112                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00113"></a>00113             }
<a name="l00114"></a>00114             <span class="keywordflow">else</span>
<a name="l00115"></a>00115             {
<a name="l00116"></a>00116                 <span class="keywordflow">return</span> 0;
<a name="l00117"></a>00117             }
<a name="l00118"></a>00118         }
<a name="l00119"></a>00119     <span class="keyword">public</span>:
<a name="l00120"></a><a class="code" href="classOgre_1_1ParamDictionary.html#f3f46fdeacdb40c4dc234cd3540cd701">00120</a>         <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>()  {}
<a name="l00127"></a><a class="code" href="classOgre_1_1ParamDictionary.html#411fa9cc6ca47ea388307fdd7841f547">00127</a>         <span class="keywordtype">void</span> addParameter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection...">ParameterDef</a>&amp; paramDef, <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* paramCmd)
<a name="l00128"></a>00128         {
<a name="l00129"></a>00129             mParamDefs.push_back(paramDef);
<a name="l00130"></a>00130             mParamCommands[paramDef.<a class="code" href="classOgre_1_1ParameterDef.html#b22036d8dcec3fe262e88316e55d9a13">name</a>] = paramCmd;
<a name="l00131"></a>00131         }
<a name="l00137"></a><a class="code" href="classOgre_1_1ParamDictionary.html#b0f6c3fd225dc9d3a8a2c4ff6ef6ffda">00137</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#1838c2b0619ade1f5e29767062212872">ParameterList</a>&amp; getParameters(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00138"></a>00138 <span class="keyword">        </span>{
<a name="l00139"></a>00139             <span class="keywordflow">return</span> mParamDefs;
<a name="l00140"></a>00140         }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     };
<a name="l00145"></a><a class="code" href="namespaceOgre.html#5d9132de11e12aae2de5536d6032fef9">00145</a>     <span class="keyword">typedef</span> std::map&lt;String, ParamDictionary&gt; <a class="code" href="namespaceOgre.html#5d9132de11e12aae2de5536d6032fef9">ParamDictionaryMap</a>;
<a name="l00146"></a>00146     
<a name="l00156"></a><a class="code" href="classOgre_1_1StringInterface.html">00156</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a> 
<a name="l00157"></a>00157     {
<a name="l00158"></a>00158     <span class="keyword">protected</span>:
<a name="l00159"></a>00159 
<a name="l00161"></a><a class="code" href="classOgre_1_1StringInterface.html#5e08eb863343f9c60f6ef9344a48075b">00161</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#5d9132de11e12aae2de5536d6032fef9">ParamDictionaryMap</a> msDictionary;
<a name="l00162"></a>00162 
<a name="l00164"></a><a class="code" href="classOgre_1_1StringInterface.html#baa2b2c02f22cff7a65ba43b4daea538">00164</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mParamDictName;
<a name="l00165"></a>00165 
<a name="l00176"></a><a class="code" href="classOgre_1_1StringInterface.html#681773443d95aea05a486c5d22c15bd1">00176</a>         <span class="keywordtype">bool</span> createParamDictionary(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; className)
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178             mParamDictName = className;
<a name="l00179"></a>00179             <span class="keywordflow">if</span> (msDictionary.find(className) == msDictionary.end())
<a name="l00180"></a>00180             {
<a name="l00181"></a>00181                 msDictionary[className] = <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>();
<a name="l00182"></a>00182                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00183"></a>00183             }
<a name="l00184"></a>00184             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keyword">public</span>:
<a name="l00189"></a>00189 
<a name="l00191"></a><a class="code" href="classOgre_1_1StringInterface.html#a86a8941e57b203088797a4b28da8c4d">00191</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a>() {}
<a name="l00192"></a>00192 
<a name="l00200"></a><a class="code" href="classOgre_1_1StringInterface.html#e3e13925bde11db245f6c9bbf5031a93">00200</a>         <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* getParamDictionary(<span class="keywordtype">void</span>)
<a name="l00201"></a>00201         {
<a name="l00202"></a>00202             ParamDictionaryMap::iterator i = msDictionary.find(mParamDictName);
<a name="l00203"></a>00203             <span class="keywordflow">if</span> (i != msDictionary.end())
<a name="l00204"></a>00204             {
<a name="l00205"></a>00205                 <span class="keywordflow">return</span> &amp;(i-&gt;second);
<a name="l00206"></a>00206             }
<a name="l00207"></a>00207             <span class="keywordflow">else</span>
<a name="l00208"></a>00208             {
<a name="l00209"></a>00209                 <span class="keywordflow">return</span> 0;
<a name="l00210"></a>00210             }
<a name="l00211"></a>00211         }
<a name="l00212"></a>00212 
<a name="l00213"></a><a class="code" href="classOgre_1_1StringInterface.html#3bfa7791753a155b222dfb2706e5218c">00213</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* getParamDictionary(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword">        </span>{
<a name="l00215"></a>00215             ParamDictionaryMap::const_iterator i = msDictionary.find(mParamDictName);
<a name="l00216"></a>00216             <span class="keywordflow">if</span> (i != msDictionary.end())
<a name="l00217"></a>00217             {
<a name="l00218"></a>00218                 <span class="keywordflow">return</span> &amp;(i-&gt;second);
<a name="l00219"></a>00219             }
<a name="l00220"></a>00220             <span class="keywordflow">else</span>
<a name="l00221"></a>00221             {
<a name="l00222"></a>00222                 <span class="keywordflow">return</span> 0;
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225 
<a name="l00231"></a>00231         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#1838c2b0619ade1f5e29767062212872">ParameterList</a>&amp; getParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00247"></a>00247         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> setParameter(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; value);
<a name="l00257"></a>00257         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setParameterList(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>&amp; paramList);
<a name="l00269"></a><a class="code" href="classOgre_1_1StringInterface.html#57397ce47f649e66c5654da05207df0b">00269</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getParameter(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)<span class="keyword"> const</span>
<a name="l00270"></a>00270 <span class="keyword">        </span>{
<a name="l00271"></a>00271             <span class="comment">// Get dictionary</span>
<a name="l00272"></a>00272             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* dict = getParamDictionary();
<a name="l00273"></a>00273 
<a name="l00274"></a>00274             <span class="keywordflow">if</span> (dict)
<a name="l00275"></a>00275             {
<a name="l00276"></a>00276                 <span class="comment">// Look up command object</span>
<a name="l00277"></a>00277                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>* cmd = dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#6b324fb02bdd70f7fdd6566fb634e1dc" title="Retrieves the parameter command object for a named parameter.">getParamCommand</a>(name);
<a name="l00278"></a>00278 
<a name="l00279"></a>00279                 <span class="keywordflow">if</span> (cmd)
<a name="l00280"></a>00280                 {
<a name="l00281"></a>00281                     <span class="keywordflow">return</span> cmd-&gt;<a class="code" href="classOgre_1_1ParamCommand.html#e47ea550693403baebbcde11c59e074f">doGet</a>(<span class="keyword">this</span>);
<a name="l00282"></a>00282                 }
<a name="l00283"></a>00283             }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285             <span class="comment">// Fallback</span>
<a name="l00286"></a>00286             <span class="keywordflow">return</span> <span class="stringliteral">""</span>;
<a name="l00287"></a>00287         }
<a name="l00300"></a><a class="code" href="classOgre_1_1StringInterface.html#702af78cbc4869e64c369fb11c4f1eb5">00300</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyParametersTo(<a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a>* dest)<span class="keyword"> const</span>
<a name="l00301"></a>00301 <span class="keyword">        </span>{
<a name="l00302"></a>00302             <span class="comment">// Get dictionary</span>
<a name="l00303"></a>00303             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a>* dict = getParamDictionary();
<a name="l00304"></a>00304 
<a name="l00305"></a>00305             <span class="keywordflow">if</span> (dict)
<a name="l00306"></a>00306             {
<a name="l00307"></a>00307                 <span class="comment">// Iterate through own parameters</span>
<a name="l00308"></a>00308                 ParameterList::const_iterator i;
<a name="l00309"></a>00309             
<a name="l00310"></a>00310                 <span class="keywordflow">for</span> (i = dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#37e4ea1d0c014e743b815b6a829f5a75" title="Definitions of parameters.">mParamDefs</a>.begin(); 
<a name="l00311"></a>00311                 i != dict-&gt;<a class="code" href="classOgre_1_1ParamDictionary.html#37e4ea1d0c014e743b815b6a829f5a75" title="Definitions of parameters.">mParamDefs</a>.end(); ++i)
<a name="l00312"></a>00312                 {
<a name="l00313"></a>00313                     dest-&gt;<a class="code" href="classOgre_1_1StringInterface.html#ce884b65b722ead9b920b9abf27bf815" title="Generic parameter setting method.">setParameter</a>(i-&gt;name, getParameter(i-&gt;name));
<a name="l00314"></a>00314                 }
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318         }
<a name="l00319"></a>00319 
<a name="l00323"></a>00323         <span class="keyword">static</span> <span class="keywordtype">void</span> cleanupDictionary () ;
<a name="l00324"></a>00324 
<a name="l00325"></a>00325     };
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="preprocessor">#endif</span>
<a name="l00332"></a>00332 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
